<?
/*  
	This file is a shared library and contains code that is used
	by more than one website. Everything that is specific to a
	certain website must go in cfg_local.inc.php.

	If you really need to change functions in this file, please
	send them to dag@wieers.com.
*/ 
/*
	Description: Creates a directory-structured path (mod_structure ?)
	Description: Creates a directory-structured menu

		structure_delimiter

		menu_updated_format
		menu_delimiter
		menu_end_delimiter
		menu_expand_all
		hidden_paths
*/

	/* Default configuration variables */
    if (empty($cfg['structure_delimiter']))
		$cfg['structure_delimiter']='&nbsp;&gt;&nbsp;';

    if (empty($cfg['menu_updated_format']))
		$cfg['menu_updated_format']='D d F Y H:i T';

    if (empty($cfg['menu_expand_all']))
		$cfg['menu_expand_all']=false;

	if (empty($cfg['structure_delimiter']))
		$cfg['structure_delimiter']='&gt;&nbsp;';

    if (empty($cfg['menu_delimiter']))
		$cfg['menu_delimiter']='&middot;&nbsp;';

    if (empty($cfg['menu_end_delimiter']))
		$cfg['menu_end_delimiter']='&middot;&nbsp;';

	if (empty($cfg['menu_file']))
		$cfg['menu_file']='.menu';

	/* Reading titles */
	_setRelDirname();
	$temp=explode('/',$ENV['RELDIRNAME']);
	$p='';
	$fp=$cfg['path'];
	for($i=0;$i<count($temp);$i++) {
//		echo "TEST: $ENV[RELDIRNAME] | $temp[$i] | $p | $fp<br>\n";
		if ($temp[$i]!='') {
			$p.=$temp[$i].'/';
			$fp="$cfg[path]$p";
		}
		_setTitle("$ENV[DOCUMENT_ROOT]$fp","$fp");
	}
	if (is_readable("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]") and 
		(empty($title[$ENV['REQUEST_NAME']]))) 
		_setTitle("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]",$ENV['REQUEST_NAME']);

function _updated() {
	global $ENV,$cfg;
	echo '<div class="updated">Last modified on: ';
	echo date($cfg['menu_updated_format'],filemtime("$ENV[DOCUMENT_ROOT]$ENV[REQUEST_NAME]"));
	echo '</div>';
}

function _structure($pagetitle) {
	global $ENV,$title,$cfg;
	echo "<span class=\"structure\">";
	reset($title);
	while (list($p,$t)=each($title)) {
		if ($p!=$ENV['REQUEST_NAME']) {
			echo $cfg['structure_delimiter']; _link($p,$t);
		} else {
			echo "$cfg[structure_delimiter]<span class=\"structactive\">$pagetitle</span>";
		}
		echo '&nbsp;';
	}
	echo "</span>\n";
}

function _menu() {
	echo "\n<!-- menu start -->\n";
	echo "<span class=\"menu\">\n";
	_printMenu('/');
	echo "</span>\n";
	echo "<!-- menu end -->\n";
}

function _printDepth($i) {
	global $cfg;
	$str='';
	for ($j=1;$j<$i;$j++) $str.=$cfg['menu_delimiter'];
	if ($i>=1) 
		$str.=$cfg['menu_end_delimiter'];
	return $str;
}

function _printMenu($path) {
	global $cfg, $ENV;

	echo "\n";

	$REQUEST=$ENV['REQUEST_NAME'];
	$temp=explode('/',$path);
	$i=count($temp);

	$fp=_rtrim("$cfg[path]$path",'/');

	if (is_dir("$ENV[DOCUMENT_ROOT]$fp") and
		is_readable("$ENV[DOCUMENT_ROOT]$fp/$cfg[menu_file]")) {
		$fp=fopen("$ENV[DOCUMENT_ROOT]$fp/$cfg[menu_file]",'r');
		while ($data=fgetcsv($fp,1000)) {
			if(empty($data) or
				eregi('^#',$data[0])) 
				continue;
			echo _printDepth($i-2);
			if (empty($data[1])) $data[1]='';
			if (empty($data[2])) $data[2]='';
			$link=$data[0];
			$file=substr($data[0],0,strcspn($data[0],'?#'));
			$title=$data[1];
			$descr=$data[2];
			if (!empty($link) and !empty($descr)) _setDescr($link,$descr);
			if (!empty($link) and $title=='') $title=_readTitle("$ENV[DOCUMENT_ROOT]$file",'');
			if (empty($link)) {
				if (!empty($title))
					echo "<span class=\"nolink\">$title</span><br>";
				else 
					echo '<br>';
			} elseif (is_dir("$ENV[DOCUMENT_ROOT]$link") and
					is_readable("$ENV[DOCUMENT_ROOT]$link/$cfg[menu_file]")){
				if ($link==$ENV['REQUEST_NAME']) {
					_link('#',$title,'activesub'); echo "<br>\n";
					_printMenu($link);
				} elseif (eregi("^$file",$ENV['REQUEST_NAME'])) {
					_link($file,$title,'relatedsub'); echo "<br>\n";
					_printMenu($file);
				} else {
					_link($file,$title,'sub'); echo '<br>';
					if ($cfg['menu_expand_all'] and
						!ereg($cfg['hidden_paths'],$link)) {
						_printMenu($file);
					}
				}
			} elseif (is_readable("$ENV[DOCUMENT_ROOT]$file") or
						is_dir("$ENV[DOCUMENT_ROOT]$file") or
  						eregi('^javascript:',$link)) {
				if ($file==$ENV['REQUEST_NAME']) {
					_link($link,$title,'active'); echo '<br>';
				} elseif (eregi("^$path","$link")) {
					_link($link,$title); echo '<br>';
//				} elseif (is_dir("$ENV[DOCUMENT_ROOT]$file")) {
//					_link($link,"$title..",'external'); echo '<br>';
				} else {
					_link($link,"$title..",'external'); echo '<br>';
				}
			} elseif (eregi('^ftp:',$link) or
						eregi('^file:',$link) or
						eregi('^http:',$link) or
						eregi('^https:',$link)) {
					_link($link,"$title..",'external'); echo '<br>';
			} else {
					echo "<textspan class=\"missing\" title=\"$descr\">$title</textspan><br>";
			}
			echo "\n";
		}
		fclose ($fp);
	}
}
?>
