<?
/*  
	This file is a shared library and contains code that is used
	by more than one website. Everything that is specific to a
	certain website must go in cfg_local.inc.php.

	If you really need to change functions in this file, please
	send them to dag@wieers.com.
*/ 
	/* Turn on output buffering */
	ob_start();
	global $ENV, $cfg, $descr, $in, $title;

	$in=$ENV=array();
//	$ENV=$GLOBALS;

	/* getting parameters */
	if(!empty($HTTP_POST_VARS)) 
		$in=$HTTP_POST_VARS;
	else
		$in=$HTTP_GET_VARS;

	function _rtrim($str,$charlist) {
		$rev=strrev($str);
		$rev=substr($rev,strspn($rev,$charlist));
		return strrev($rev);
	}

	/* base variables */ 
	$INDEXFILE='index.php';
	$ENV['DOCUMENT_ROOT']=getenv('DOCUMENT_ROOT');
	$ENV['HTTPS']=getenv('HTTPS');
	$ENV['HTTP_HOST']=_rtrim(getenv('HTTP_HOST'),'/');
	$ENV['HTTP_REFERER']=getenv('HTTP_REFERER');
	$ENV['HTTP_USER_AGENT']=getenv('HTTP_USER_AGENT');
	$ENV['PATH_TRANSLATED']=getenv('PATH_TRANSLATED');
	$ENV['PHP_AUTH_PW']=getenv('PHP_AUTH_PW');
	$ENV['PHP_AUTH_TYPE']=getenv('PHP_AUTH_TYPE');
	$ENV['PHP_AUTH_USER']=getenv('PHP_AUTH_USER');
	$ENV['PHP_SELF']=getenv('PHP_SELF');
	$ENV['REMOTE_ADDR']=getenv('REMOTE_ADDR');
	$ENV['REMOTE_HOST']=getenv('REMOTE_HOST');
	$ENV['REMOTE_USER']=getenv('REMOTE_USER');
	$ENV['REQUEST_URI']=getenv('REQUEST_URI');
	list($ENV['REQUEST_NAME'])=split('[#?]',$ENV['REQUEST_URI']);
	$ENV['REQUEST_NAME']=str_replace($INDEXFILE,'',$ENV['REQUEST_NAME']);
	$ENV['SCRIPT_NAME']=getenv('SCRIPT_NAME');
	$ENV['SCRIPT_NAME']=str_replace($INDEXFILE,'',$ENV['SCRIPT_NAME']);
	$ENV['SERVER_ADMIN']=getenv('SERVER_ADMIN');
	$ENV['SERVER_NAME']=getenv('SERVER_NAME');
	$ENV['SERVER_SOFTWARE']=getenv('SERVER_SOFTWARE');
	$ENV['QUERY_STRING']=getenv('QUERY_STRING');

	/* This didn't work ;-( */
//	if (isset($PHP_AUTH_USER)) $ENV['REMOTE_USER']=$PHP_USER_AUTH;

//	$DIRNAME=dirname($ENV[SCRIPT_NAME]."file");
	$ENV['DIRNAME']=dirname($ENV['REQUEST_NAME'].'file').'/';
	if ($ENV['DIRNAME']=='//') $ENV['DIRNAME']='/';
	$MANPAGE='http://www.rivertown.net/cgi-bin/man-cgi?';
	$NRHEADLINES=8;
//	$CSS=false;
	$CSS=true;
	$IE4=$IE3=$NS4=$NS3=$WIN=false;
//	$NS4=1;

	/* initializing arrays */
	$descr=$title=$cfg=array();

	function _errorhandler($nr,$str,$file,$line,$context) {
		global $ENV;
		$user_errors=array(E_USER_ERROR, E_ERROR, E_USER_NOTICE, E_PARSE);
		if (!in_array($nr,$user_errors)) return 0;
		$type=array(
			E_ERROR			=> 'Error',				// 1
			E_WARNING		=> 'Warning',			// 2
			E_PARSE			=> 'Parse Error',		// 4
			E_NOTICE		=> 'Notice',			// 8
			E_CORE_ERROR		=> 'Core Error',		// 16
			E_CORE_WARNING		=> 'Core Warning',		// 32
			E_COMPILE_ERROR		=> 'Compile Error',		// 64
			E_COMPILE_WARNING	=> 'Compile Warning',		// 128
			E_USER_ERROR		=> 'User Error',		// 256
			E_USER_WARNING		=> 'User Warning',		// 512
			E_USER_NOTICE		=> 'User Notice',		// 1024
		);
		if ($ENV['error_body']=='') {
			$ENV['error_subject']="[WEB] PHP errors in http://$ENV[SERVER_NAME]$ENV[REQUEST_URI]";
			$ENV['error_body']="referer: $ENV[HTTP_REFERER]\n".
				"bad link: http://$ENV[SERVER_NAME]$ENV[REQUEST_URI]\n".
				"http_user_agent: $ENV[HTTP_USER_AGENT]\n".
				"remote_addr: $ENV[REMOTE_ADDR] ($ENV[REMOTE_HOST])\n\n";
		}
		$ENV['error_body'].="\tPHP $type[$nr] [$nr]: $str "."at line $line in $file\n\n";
//                              print_r($context)."\n\n";
		if($nr==E_ERROR) {
			_foot();
			include('mod_append.inc.php');
		}
	}

	if (empty($in['debug'])) {
		set_error_handler('_errorhandler');
/*		if (set_error_handler('_errorhandler')) 
			error_reporting(E_ALL ^ E_PARSE);	// E_PARSE doesn't use _errorHandler
		else  */
			error_reporting(0); 
	} else {
		$cfg['debug']=$in['debug'];
		if ($cfg['debug']=='all')
			error_reporting(E_ALL);
		else 
			error_reporting(E_ALL ^ E_NOTICE);
	}
	
	/* default settings (meta-tags and order) */
$meta['keywords']='';
	$meta['description']='';
	$meta['robots']='index,follow';
	$meta['author']='Dag Wieers <dag@wieers.com>';
	$meta['copyright']='&copy; 1995-2003 Dag Wieers <dag@wieers.com>. All rights reserved.';
//	$meta['email']='dag@wieers.com';
//	$meta['generator']='vim+php+ht-dig+apache+linux=Open Source at its best.';
	$meta['language']='English';

	$cfg['charset']='iso-8859-15';
	$cfg['internal_hosts']='^$';
	$cfg['lang']='en';
	$cfg['path']='/';

	$headers=getallheaders();

	/* Search module and load it */
	function _searchModule($file) {
		global $ENV, $cfg;
		$t=explode('/',_rtrim($ENV['DIRNAME'],'/'));
		for($i=1;$i<=count($t);$i++) {
			$p='/';
			for($j=1;$j<count($t)+1-$i;$j++) $p.=$t[$j].'/';
			if (is_readable("$ENV[DOCUMENT_ROOT]/$p$file")) {
				if (!empty($cfg['debug']))
					echo "<!-- DEBUG: Module $p$file found and loaded -->\n";
				include_once("$ENV[DOCUMENT_ROOT]/$p$file");
				return 0;
			} else {
				if (!empty($cfg['debug']))
					echo "<!-- DEBUG: Module $p$file not found -->\n";
			}
		}
		return 1;
	}

	function _loadModule($file) {
		global $ENV, $cfg;
		if (is_readable("$ENV[DOCUMENT_ROOT]$cfg[path]/$file")) {
			if (!empty($cfg['debug']))
				echo "<!-- DEBUG: Module $cfg[path]$file loaded -->\n";
			include_once("$ENV[DOCUMENT_ROOT]/$cfg[path]$file");
			return 0;
		} else {
			if (!empty($cfg['debug'])) {
				echo "<!-- DEBUG: Module $cfg[path]$file not loaded -->\n";
				echo "<!-- DEBUG: Module /$file loaded -->\n";
			}
			include_once($file);
		}
		return 1;
	}

	/* Load site-specific stuff */
	_searchModule('cfg_local.inc.php');

	foreach(explode(',',$cfg['modules']) as $module)
		_loadModule("mod_$module.inc.php");
	setlocale(LC_ALL,$cfg['lang']);
	_setRelDirname();

	/* determine browser */
/*	if (!isset($ENV[HTTP_USER_AGENT])) $ENV[HTTP_USER_AGENT]="none";
	if (ereg("Win",$ENV[HTTP_USER_AGENT],$version)) $WIN=true;
	if (ereg("MSIE.([0-9])",$ENV[HTTP_USER_AGENT],$version)) {
		$ver=(int)$version[1];
		if ($ver>=4) $IE4=true;
		elseif ($ver==3) $IE3=true;
	} elseif (ereg("ozilla.([0-9])",$ENV[HTTP_USER_AGENT],$version)) {
		$ver=(int)$version[1];
		if ($ver>=4) $NS4=true; 
		elseif($ver==3) $NS3=true; 
	}*/

	/* determine browser */
//	if (!isset($ENV[HTTP_USER_AGENT])) $ENV[HTTP_USER_AGENT]="none";
//	if (eregi("Win",$ENV[HTTP_USER_AGENT])) $WIN=true;
	if (preg_match('/MSIE [4-9]/i',$ENV['HTTP_USER_AGENT'])) {
		$IE4=true;
	} elseif (preg_match('/MSIE 3/i',$ENV['HTTP_USER_AGENT'])) {
		$IE3=true;
	} elseif (preg_match('/ozilla\/[5-9]/i',$ENV['HTTP_USER_AGENT'])) {
		$NS6=true;
	} elseif (preg_match('/ozilla\/4/i',$ENV['HTTP_USER_AGENT'])) {
		$NS4=true; 
	} elseif (preg_match('/ozilla\/3/i',$ENV['HTTP_USER_AGENT'])) {
		$NS3=true; 
	}

	/* get real doc-root */
/*
	if (ereg("^/nl/",$ENV['REQUEST_NAME'])) 
		$cfg['path']="/nl/";
	elseif (ereg("^/fr/",$ENV['REQUEST_NAME'])) 
		$cfg['path']="/fr/";
	elseif (ereg("^/de/",$ENV['REQUEST_NAME'])) 
		$cfg['path']="/de/";
*/

	function _isPrivate() {
		global $ENV, $cfg;
		if (($ENV['REMOTE_HOST']!='' and preg_match("/$cfg[internal_hosts]/i",$ENV['REMOTE_HOST'])) or
			(preg_match("/$cfg[internal_hosts]/i",$ENV['REMOTE_ADDR'])))
			return 1;
		return 0; 
	}

	function _setTitle($file,$name) {
		global $title;
		if (empty($title[$name])) 
			$title[$name]=_readTitle($file);
	}

	function _readTitle(/* $file,$name */) {
		global $title;
		$numargs=func_num_args();
		$file=func_get_arg(0);
		if (!empty($title[$file]))
			return $title[$file];
		if (is_file($file)) {
			if (@is_readable($file))
				$name=_getTitle($file);
		} else {
			if (@is_readable("$file/.title"))
				$name=rtrim(current(file("$file/.title")));
			elseif (@is_readable("$file/index.php"))
				$name=_getTitle("$file/index.php");
			elseif (@is_readable("$file/index.html"))
				$name=_getTitle("$file/index.html");
			elseif (@is_readable("$file/index.cgi"))
				$name=_getTitle("$file/index.cgi");
		}
		if (empty($name)) {
			if ($numargs==2) {
				$name=func_get_arg(1);
				if ($name!="") $name="[$name]";
			} else {
				$name="[".basename($file)."]";
			}
		}
		return $name;
	}

	function _getTitle($file) {
		if ($fd=fopen($file,'r')) {
			$contents=fread($fd, 2048);
			fclose ($fd);
			if(eregi('_head\([\'\"]([^\"]*)[\'\"]\)',$contents,$regs) or
				 eregi("<title\n?>([^<]*)</title\n?>",$contents,$regs)) {
				return strip_tags($regs[1]);
			}
		}
		return false;
	}

	function _setDescr($file,$desc) {
		global $descr;
		if (empty($descr[$file])) 
			$descr[$file]=$desc;
	}

	function _readDescr($file) {
		global $descr, $title, $cfg, $ENV;
		$desc=false;
		if (!empty($descr[$file]))
			return $descr[$file];
		$full="$ENV[DOCUMENT_ROOT]/$file";
		if (is_file($full)) {
			if (is_readable($full))
				$desc=_getDescr($full);
		} else {
			if (is_readable("$full/.descr"))
				$desc=rtrim(current(file("$full/.descr")));
			elseif (is_readable("$full/index.php"))
				$desc=_getDescr("$full/index.php");
			elseif (is_readable("$full/.readme"))
				$desc=_getDescr("$full/.readme");
		}
		if (!$desc) {
			if (!empty($title[$file]))
				return $title[$file];
		}
		$descr[$file]=$desc;
		return $desc;
	}

	function _getDescr($file) {
		global $title;
		if ($fd=fopen($file,'r')) {
			$contents=fread($fd, 2048);
			fclose ($fd);
			if(eregi('\$meta\[[\"]description[\"]\]=[\"]([^\"]*)[\"]',$contents,$regs)
//				or preg_match('/<div class="intro">(.*?)<\/div>/s',$contents,$regs)
				)
				return strip_tags($regs[1]);
			elseif (!empty($title[$file]))
				return $title[$file];
		}
		return false;
	}

	function _ltrim($str,$charlist) {
		return substr($str,strspn($str,$charlist));
	}

	/* Clean up $cfg[path] */
	function _setRelDirname() {
		global $ENV, $cfg;
		if ($cfg['path']!='' and $cfg['path']!='/') {
			$ENV['RELDIRNAME']='/'._ltrim(str_replace(_ltrim($cfg['path'],'/'),'',$ENV['DIRNAME']),'/');
		} else {
			$cfg['path']='/';
			$ENV['RELDIRNAME']=$ENV['DIRNAME'];
		}
	}

	function spc($width,$height,$alt) {
		echo "<img src=\"/images/spacer.gif\" width=\"$width\" height=\"$height\" border=\"0\" alt=\"$alt\" hspace=\"0\" vspace=\"0\">";
	}

	function _getLastUpdated() {
		global $meta;
		if (!empty($meta['id']) and ereg('Id: .+,v .+ ([0-9]{4})/([0-9]{2})/([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2}) .+ Exp ',$meta['id'],$date))
			return mktime($date[4],$date[5],$date[6],$date[2],$date[3],$date[1]);
	}

	function _lastUpdated($file) {
		global $cfg;
		if ($file) {
			if(is_file($file))
				echo '<small><b>Updated '.gmdate('d F Y',filemtime($file))."</b></small>\n";
			else
				echo '<small><b>File is missing!</b></small>';
		} else {
			if ($date=_getLastUpdated())
				echo "<div id=\"updated\">".$cfg['last updated'].strftime("%d %B %Y",$date)."</div>\n";
		}
	}

	/* creates a filename of a string */
	function _createName($title) {
		$name='';
		$title=strtolower($title);
		for ($i=0;$i<strlen($title);$i++) {
			$chr=substr($title,$i,1);
			if ((ord($chr)>=ord('a') and ord($chr)<=ord('z')) or
				(ord($chr)>=ord('0') and ord($chr)<=ord('9') and $name!=''))
				$name.=$chr;
			elseif($chr==' ')
				$name.='-';
		}
		return $name;
	}

	function _debugArray($aname,$array) {
		if (!empty($array)) {
			echo "\n";
			reset($array);
			while (list($name,$value)=each($array))
				echo "<!-- \$$aname"."[\"$name\"]=\"$value\" -->\n";
		}
	}

	/* Print debug information */
	function _debug() {
		global $in, $cfg, $descr, $menu, $title, $in, $headers, $ENV, $GLOBALS;
		_debugArray('cfg',$cfg);
		_debugArray('descr',$descr);
		_debugArray('in',$in);
		_debugArray('menu',$menu);
		_debugArray('title',$title);
		_debugArray('headers',$headers);
		_debugArray('ENV',$ENV);
//		_debugArray('GLOBALS',$GLOBALS);
		echo "\n";
	}

	if (!empty($cfg['debug']))
		_debug();

/* End of shared stuff. */

/* Move modified functions below and change them. */
?>
